#include <ft/test.h>
#include <ft/all-tests.h>
#include <gint/rtc.h>
#include <time.h>

static void _ft_time_clock(ft_test *t)
{
	rtc_time_t rtc;
	rtc_get_time(&rtc);

	static char const weekday_names[8][3] = {
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "???",
	};
	int wday = (rtc.week_day >= 7) ? 7 : rtc.week_day;
	ft_log(t, "RTC time: %04d-%02d-%02d (%.3s) %02d:%02d:%02d (%d t)\n",
		rtc.year, rtc.month+1, rtc.month_day, weekday_names[wday],
		rtc.hours, rtc.minutes, rtc.seconds, rtc.ticks);

	ft_log(t, "rtc_ticks() = %ld\n", rtc_ticks());

	clock_t c = clock();
	ft_log(t, "clock() = %llu\n", c);

	time_t ti = time(NULL);
	ft_log(t, "time() = %llu\n", ti);
}

ft_test ft_time_clock = {
	.name = "Obtaining time",
	.function = _ft_time_clock,
};
