#include <ft/test.h>
#include <ft/all-tests.h>
#include <time.h>

static void _ft_time_functions(ft_test *t)
{
	time_t t1 = 1638650741;
	time_t t2 = 1573929834;
	time_t t3 = 1237432983;
	time_t t4 = 1839824619;

	/* gmtime() uses mktime() internally, this saves us the need to build
	   some struct tm's manually */
	struct tm tm1 = *gmtime(&t1);
	struct tm tm2 = *gmtime(&t2);
	struct tm tm3 = *gmtime(&t3);
	struct tm tm4 = *gmtime(&t4);

	ft_log(t, "%llu:\n  %s", t1, asctime(&tm1));
	ft_assert(t, !strcmp(asctime(&tm1), "Sat Dec  4 20:45:41 2021\n"));
	ft_assert(t, mktime(&tm1) == t1);

	ft_log(t, "%llu:\n  %s", t2, asctime(&tm2));
	ft_assert(t, !strcmp(asctime(&tm2), "Sat Nov 16 18:43:54 2019\n"));
	ft_assert(t, mktime(&tm2) == t2);

	ft_log(t, "%llu:\n  %s", t3, asctime(&tm3));
	ft_assert(t, !strcmp(asctime(&tm3), "Thu Mar 19 03:23:03 2009\n"));
	ft_assert(t, mktime(&tm3) == t3);

	ft_log(t, "%llu:\n  %s", t4, asctime(&tm4));
	ft_assert(t, !strcmp(asctime(&tm4), "Thu Apr 20 06:23:39 2028\n"));
	ft_assert(t, mktime(&tm4) == t4);
}

ft_test ft_time_functions = {
	.name = "All time functions",
	.function = _ft_time_functions,
};
